﻿'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Imports System.Reflection
Imports System.Reflection.Emit
Imports System.Windows.Forms
Imports System.Text
Imports System.Aspect

Namespace Controls

    Public Class AspectsPanel

        Private _Assy As Assembly
        Public Property Assy() As Assembly
            Get
                Return _Assy
            End Get
            Set(ByVal value As Assembly)
                _Assy = value
                PopulateAspects()
            End Set
        End Property

        Private Sub PopulateAspects()
            Me.lbAspects.Items.Clear()
            If Me.Assy Is Nothing Then Return
            Dim spool As New List(Of String)
            'TODO: this is not optimal, not that is should matter considering this will be a dev-only feature
            For Each a As IAspect In Me.Assy.GetTypes.SelectMany(Of IAspect)(Function(t As Type) (t.GetCustomAttributes(False).OfType(Of IAspect)()))
                If Not spool.Contains(a.AspectUIName) Then spool.Add(a.AspectUIName)
            Next
            For Each Name As String In spool
                Me.lbAspects.Items.Add(Name)
            Next
        End Sub

    End Class

End Namespace