﻿'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Imports System.Reflection

Namespace Controls

    Public Class CreatedMethodsPanel

        Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
            PopulateDelegates()
            MyBase.OnLoad(e)
        End Sub

        Private Sub PopulateDelegates()
            lbMethods.Items.Clear()
            For Each d As System.Delegate In System.ExecutorServices.CreatedMethods
                lbMethods.Items.Add(d)
            Next
        End Sub

        Private Sub lbMethods_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbMethods.SelectedIndexChanged
            Dim o As Object = lbMethods.SelectedItem
            If o Is Nothing Then
                Me.PropertyGrid1.SelectedObject = Nothing
            Else
                Dim d As System.Delegate = DirectCast(o, System.Delegate)
                Me.PropertyGrid1.SelectedObject = d.Method
            End If
        End Sub

        Private Sub btnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefresh.Click
            PopulateDelegates()
        End Sub

    End Class

End Namespace