﻿'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Imports System.Text
Imports System.Reflection

Public Module Utils

    Public Function GetInnerMostExceptionMessage(ByVal ex As Exception) As String
        Dim ret As String = Nothing
        Dim iex As Exception = ex
        While Not iex.InnerException Is Nothing
            iex = iex.InnerException
        End While
        ret = iex.Message
        Return ret
    End Function

    Public Function GetFullExceptionMessage(ByVal ex As Exception) As String
        Dim ret As New StringBuilder
        Dim iex As Exception = ex
        ret.AppendLine(iex.Message)
        While Not iex.InnerException Is Nothing
            iex = iex.InnerException
            If Not iex Is GetType(TargetInvocationException) Then
                ret.AppendLine(iex.Message)
            End If
        End While
        Return ret.ToString
    End Function

End Module
