'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Imports System.Xml.Serialization
Imports System.Reflection
Imports System.Text
Imports System.Aspect

Partial Structure Contract

    <Serializable()> _
    Public Structure AssemblyInfo
        Implements IEquatable(Of AssemblyInfo)

        Public Sub New(ByVal c As IAspect)
            Dim d As DelegateInfo = c.DelegateInfo
            Dim asm As Assembly = d.DeclaringDelegate.Assembly
            Dim CodeBase As String = d.DeclaringDelegate.Assembly.CodeBase
            File = IO.Path.GetFileName(CodeBase)
            Name = asm.GetName.FullName
            ImageRuntimeVersion = asm.ImageRuntimeVersion()
            FileLastModified = System.IO.File.GetLastWriteTime(CodeBase.Replace("file:///", "")).ToString()
        End Sub

        Public File, Name, ImageRuntimeVersion, FileLastModified As String

        Public Overloads Function Equals(ByVal other As AssemblyInfo) As Boolean Implements System.IEquatable(Of AssemblyInfo).Equals
            Dim ret As Boolean = True
            ret = ret AndAlso Me.File = other.File
            ret = ret AndAlso Me.Name = other.Name
            ret = ret AndAlso Me.ImageRuntimeVersion = other.ImageRuntimeVersion
            'ret = ret AndAlso Me.FileLastModified = other.FileLastModified
            Return ret
        End Function

    End Structure

End Structure