'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Imports System.Xml.Serialization
Imports System.Reflection
Imports System.Text
Imports System.Aspect

Partial Structure Contract

    <Serializable()> _
    Public Structure GeneratedInfo

        'this class is not equitable because we don't track / care about changes here - the user, machine, date, and file location can all change without functional significance

        Public Sub New(ByVal c As IAspect)
            User = Environment.UserName
            Domain = Environment.UserDomainName
            Machine = Environment.MachineName
            File = c.DelegateInfo.DeclaringDelegate.Assembly.CodeBase
            'File = File.Replace("file:///", "")
            [Date] = DateTime.Now.ToString
        End Sub

        Public User, Domain, Machine, File, [Date] As String

    End Structure

End Structure