﻿'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Imports System.Reflection

Namespace Aspect

    '<DebuggerStepThrough()> _
    <CLSCompliant(True)> _
    <AttributeUsage(AttributeTargets.Parameter Or AttributeTargets.Property Or AttributeTargets.Field)> _
    Public Class FieldAttribute
        Inherits Attribute
        Implements IContractable
        Public Sub New(ByVal iUIName As String)
            Me.New(Nothing, iUIName, Nothing, Nothing)
        End Sub
        Public Sub New(ByVal iRegisterName As String, ByVal iUIName As String)
            Me.New(iRegisterName, iUIName, Nothing, Nothing)
        End Sub
        Public Sub New(ByVal iRegisterName As String, ByVal iUIName As String, ByVal iValidator As Func(Of Object, String))
            Me.New(iRegisterName, iUIName, Nothing, iValidator)
        End Sub
        Public Sub New(ByVal iRegisterName As String, ByVal iUIName As String, ByVal iRequirements As RequirementFlags)
            Me.New(iRegisterName, iUIName, iRequirements, Nothing)
        End Sub
        Public Sub New(ByVal iRegisterName As String, ByVal iUIName As String, ByVal iRequirements As RequirementFlags, ByVal iValidator As Func(Of Object, String))
            _RegisterName = iRegisterName
            UIName = iUIName
            Requirements = iRequirements
            Validator = iValidator
        End Sub
        Private ReadOnly _RegisterName As String
        Public ReadOnly Property RegisterName() As String Implements IContractable.RegisterName
            Get
                Return _RegisterName
            End Get
        End Property
        Public ReadOnly UIName As String
        Public ReadOnly Requirements As RequirementFlags
        Public ReadOnly Validator As Func(Of Object, String)
        Public Function Validate(ByVal param As ParameterInfo, ByVal arg As Object) As String
            Dim ret As String = Nothing
            If Not Requirements = RequirementFlags.None Then
                If Requirements = (Requirements Or RequirementFlags.NotNull) Then
                    If arg Is Nothing Then Throw New ArgumentNullException(param.Name)
                End If
            End If
            If Not Validator Is Nothing Then ret = Validator.Invoke(arg)
            Return ret
        End Function
    End Class

End Namespace