﻿'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Imports System.Reflection

Namespace Aspect

    '<DebuggerStepThrough()> _
    <CLSCompliant(True)> _
    Public Class InputMapping
        Public Sub New(ByVal iFieldAttribute As FieldAttribute, ByVal iParameter As ParameterInfo)
            Parameter = iParameter
            Name = If(iFieldAttribute Is Nothing, iParameter.Name, iFieldAttribute.RegisterName)
            FieldType = iParameter.ParameterType
        End Sub
        Public ReadOnly Parameter As ParameterInfo
        Public ReadOnly Name As String
        Public ReadOnly FieldType As Type
        Public Shared Function GetMappings(ByVal m As MethodInfo) As InputMapping()
            Dim ret As New List(Of InputMapping)
            For Each p As ParameterInfo In m.GetParameters
                Dim op As FieldAttribute = p.GetCustomAttributes(True).OfType(Of FieldAttribute).FirstOrDefault
                ret.Add(New InputMapping(op, p))
            Next
            Return ret.ToArray
        End Function
    End Class

End Namespace