﻿'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Namespace Aspect

    <CLSCompliant(True)> _
    Public Interface IVerb
        ReadOnly Property UIName() As String
    End Interface

    Public Interface IContractable
        ReadOnly Property RegisterName() As String
    End Interface

    <CLSCompliant(True)> _
    Public Interface IAspect
        Inherits IVerb
        ReadOnly Property AspectID() As Guid
        ReadOnly Property AspectUIName() As String
        'TODO: management operations should be addable as aspects and not declared here
        'ReadOnly Property UserActions() As IUserAction() 
        Property DelegateInfo() As DelegateInfo
        Sub BeforeInvoke(ByVal args() As Argument)
    End Interface

    Public Interface IAspectAction
        Inherits IAspect
        Sub Execute(ByVal args() As Argument)
    End Interface

    Public Interface IAspectFunction
        Inherits IAspect
        Function GetItem(Of T As New)(ByVal Outputs() As OutputMapping, ByVal args() As Argument) As T
        Function GetItems(Of T As New)(ByVal Outputs() As OutputMapping, ByVal args() As Argument) As T()
        Function GetValue(Of T As IConvertible)(ByVal args() As Argument) As T
        Function GetValues(Of T As IConvertible)(ByVal args() As Argument) As T()
    End Interface

End Namespace
