﻿'Copyright (c) 2009 Grailtek

'Permission is hereby granted, free of charge, to any person
'obtaining a copy of this software and associated documentation
'files (the "Software"), to deal in the Software without
'restriction, including without limitation the rights to use,
'copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following
'conditions:

'The above copyright notice and this permission notice shall be
'included in all copies or substantial portions of the Software.

'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.

Imports System.Reflection

Namespace Aspect

    Public Class Item
        Implements IComparable(Of Item)
        Friend Sub New(ByVal iItem As ItemAttribute, ByVal iDeclaringInterface As Type)
            _ItemAttribute = iItem
            _DeclaringInterface = iDeclaringInterface
        End Sub
        Private _ItemAttribute As ItemAttribute
        Public ReadOnly Property ItemAttribute() As ItemAttribute
            Get
                Return _ItemAttribute
            End Get
        End Property
        Private _DeclaringInterface As Type
        Public ReadOnly Property DeclaringInterface() As Type
            Get
                Return _DeclaringInterface
            End Get
        End Property
        Public Overrides Function ToString() As String
            Return ItemAttribute.UIName
        End Function
        Public Function CompareTo(ByVal other As Item) As Integer Implements IComparable(Of Item).CompareTo
            Return String.Compare(ItemAttribute.UIName, other.ItemAttribute.UIName)
        End Function
    End Class

End Namespace